/*
 * Lazy Load - jQuery plugin for lazy loading images
 *
 * Copyright (c) 2007-2012 Mika Tuupola
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Project home:
 *   http://www.appelsiini.net/projects/lazyload
 *
 * Version:  1.7.2
 *
 */
;(function(a,b){$window=a(b),a.fn.lazyload=function(c){function f(){var b=0;d.each(function(){var c=a(this);if(e.skip_invisible&&!c.is(":visible"))return;if(!a.abovethetop(this,e)&&!a.leftofbegin(this,e))if(!a.belowthefold(this,e)&&!a.rightoffold(this,e))c.trigger("appear");else if(++b>e.failure_limit)return!1})}var d=this,e={threshold:0,failure_limit:0,event:"scroll",effect:"show",container:b,data_attribute:"original",skip_invisible:!0,appear:null,load:null};return c&&(undefined!==c.failurelimit&&(c.failure_limit=c.failurelimit,delete c.failurelimit),undefined!==c.effectspeed&&(c.effect_speed=c.effectspeed,delete c.effectspeed),a.extend(e,c)),$container=e.container===undefined||e.container===b?$window:a(e.container),0===e.event.indexOf("scroll")&&$container.bind(e.event,function(a){return f()}),this.each(function(){var b=this,c=a(b);b.loaded=!1,c.one("appear",function(){if(!this.loaded){if(e.appear){var f=d.length;e.appear.call(b,f,e)}a("<img />").bind("load",function(){c.hide().attr("src",c.data(e.data_attribute))[e.effect](e.effect_speed),b.loaded=!0;var f=a.grep(d,function(a){return!a.loaded});d=a(f);if(e.load){var g=d.length;e.load.call(b,g,e)}}).attr("src",c.data(e.data_attribute))}}),0!==e.event.indexOf("scroll")&&c.bind(e.event,function(a){b.loaded||c.trigger("appear")})}),$window.bind("resize",function(a){f()}),f(),this},a.belowthefold=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.height()+$window.scrollTop():e=$container.offset().top+$container.height(),e<=a(c).offset().top-d.threshold},a.rightoffold=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.width()+$window.scrollLeft():e=$container.offset().left+$container.width(),e<=a(c).offset().left-d.threshold},a.abovethetop=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.scrollTop():e=$container.offset().top,e>=a(c).offset().top+d.threshold+a(c).height()},a.leftofbegin=function(c,d){var e;return d.container===undefined||d.container===b?e=$window.scrollLeft():e=$container.offset().left,e>=a(c).offset().left+d.threshold+a(c).width()},a.inviewport=function(b,c){return!a.rightofscreen(b,c)&&!a.leftofscreen(b,c)&&!a.belowthefold(b,c)&&!a.abovethetop(b,c)},a.extend(a.expr[":"],{"below-the-fold":function(c){return a.belowthefold(c,{threshold:0,container:b})},"above-the-top":function(c){return!a.belowthefold(c,{threshold:0,container:b})},"right-of-screen":function(c){return a.rightoffold(c,{threshold:0,container:b})},"left-of-screen":function(c){return!a.rightoffold(c,{threshold:0,container:b})},"in-viewport":function(c){return!a.inviewport(c,{threshold:0,container:b})},"above-the-fold":function(c){return!a.belowthefold(c,{threshold:0,container:b})},"right-of-fold":function(c){return a.rightoffold(c,{threshold:0,container:b})},"left-of-fold":function(c){return!a.rightoffold(c,{threshold:0,container:b})}})})(jQuery,window);

/**
 * Author: Sergey Bondarenko (BR0kEN)
 * E-mail: broken@propeople.com.ua
 * Github: https://github.com/BR0kEN-/jTap
 * Updated: June 2, 2014
 * Version: 0.2.9
 */
!function(t,e){"use strict";var n={start:"touchstart mousedown",end:"touchend mouseup"};t.event.special[e]={setup:function(){t(this).off("click").on(n.start+" "+n.end,function(t){n.E=t.originalEvent.changedTouches?t.originalEvent.changedTouches[0]:t}).on(n.start,function(t){t.which&&1!==t.which||(n.target=t.target,n.time=(new Date).getTime(),n.X=n.E.pageX,n.Y=n.E.pageY)}).on(n.end,function(a){n.target===a.target&&(new Date).getTime()-n.time<750&&n.X===n.E.pageX&&n.Y===n.E.pageY&&(a.type=e,a.pageX=n.E.pageX,a.pageY=n.E.pageY,t.event.dispatch.call(this,a))})},remove:function(){t(this).off(n.start+" "+n.end)}},t.fn[e]=function(t){return this[t?"on":"trigger"](e,t)}}(jQuery,"tap");

/**
* MarkUtil - A Lib for Shouqu article note
* Author: wei.shi@shouqu.me
* Update: 2016-07-25
* Version: 0.1
*/
(function($){
	var MarkUtil = {

		//默认高亮类名
		"activeClassName" : navigator.userAgent.match(/Android/i) == null ? "mark-text" : "mark-text-alter",

		//设置高亮类名
		"setActiveClassName" : function(className){
			MarkUtil.activeClassName = className;
		},

		//设置注释类名
		"commentClassName" : "comment-icon",

		//默认文本节点类名
		"markSpanClassName" : "sqt",

		//设置默认文本节点类名
		"setMarkSpanClassName" : function(className){
			MarkUtil.markSpanClassName = className;
		},

		//数据格式版本号，默认为2
		"dataFormatVersion" : 1,

		//设置数据格式版本号
		"setDataFormatVersion" : function(ver){
			MarkUtil.dataFormatVersion = ver;
		},

		//系统版本号
		"osVer" : 1,
		//系统类型号
		"osType" : "android",
		//应用版本号
		"appVer" : 144,
		
		//设置系统版本
		"setOsVer" : function(intVer){
			MarkUtil.osVer = intVer;
		},
		
		//设置系统类型
		"setOsType" : function(strType){
			MarkUtil.osType = strType;
		},
		
		//设置应用版本号
		"setAppVer" : function(intVer){
			MarkUtil.appVer = intVer;
		},

		//遍历DOM
		'traverseDOM' : function(node, func){
			func(node);
			node = node.firstChild;
			while (node) {
				MarkUtil.traverseDOM(node, func);
				node = node.nextSibling;
			}
		},

		//获取一个文本节点或元素节点在其父节点中的索引
		'getNodeIndexInParentElement' : function(oNode){
			var index = -1;
			var oParentNode = oNode.parentNode;
			for(var i = 0,len = oParentNode.childNodes.length; i < len; i++){
				if(oNode == oParentNode.childNodes[i]){
					index = i;
					break;
				}
			}
			return index;
		},

		//获取一个节点元素在所有同类型节点中的索引，如果是文本节点则返回其父节点的索引
		'getElementIndexOfTagName':function(oNode){

			var index = -1;
			var node = ( oNode.nodeType == document.TEXT_NODE ? oNode.parentNode : oNode );
			var tagName = node.tagName;

			var allTags = document.getElementsByTagName(tagName),len = allTags.length;
			for( var i = 0;i < len; i++ ){
				if(allTags[i] === node){
					index = i;
					break;
				}
			}
			return index;
		},

		//根据index和tagName 获取元素节点
		'getElementByTagNameIndex':function (tag_name,index){

			var all = document.getElementsByTagName(tag_name);
			var ele = null;
			for(var i = 0, len = all.length; i < len; i++){
				if(i == index){
					ele = all[i];
					break;
				}
			}
			return ele;
		},

		//获取一个元素节点在dom中的index值
		'getNodeIndexInDOM' : function(oNode){
			for(var i in document.all){
				if(document.all[i] == oNode){
					return +i;
				}
			}
		},

		//是否包含文本节点
		'hasTextNode' : function(oNode){
			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var ret = false;
			var children = oNode.childNodes;
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.TEXT_NODE){
					ret = true;
					break;
				}
			}
			return ret;
		},

		//是否包含标记文本节点
		'hasMarkNode' : function(oNode){
			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var ret = false;
			var children = oNode.childNodes;
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.ELEMENT_NODE && children[i].className.match(MarkUtil.markSpanClassName) != null){
					ret = true;
					break;
				}
			}
			return ret;
		},

		//根据index返回一个标记节点
		'getMarkNodeByIndex': function(index){
			return document.getElementsByClassName(MarkUtil.markSpanClassName).item(index);
		},

		//返回一个节点内的标记文本节点
		'getMarkChildren' : function(oNode){

			if(oNode.nodeType != document.ELEMENT_NODE || oNode.childNodes.length  == 0){
				return false;
			}
			var children = oNode.childNodes;
			var ret = [];
			for(var i = 0; i < children.length; i++){
				if(children[i].nodeType == document.ELEMENT_NODE && children[i].className.match(MarkUtil.markSpanClassName) != null){
					ret = true;
					break;
				}
			}
		},

		//获取一个元素在同一类中的index
		'getElementIndexOfClassName' : function(ele,clsName){

			//传入的ele必须是元素节点对象
			if(ele.nodeType != document.ELEMENT_NODE || typeof clsName != 'string'){
				console.log("错误的节点类型");
				return false;
			}

			//元素不具有类名时返回-1
			if(ele.className.match(clsName) == null){
				return -1;
			}

			//遍历所有同类
			var arr = document.getElementsByClassName(clsName);
			//var arr = $("." + clsName);
			for(var i = 0; i < arr.length; i += 1){
				if(arr[i] === ele){
					return i;
				}
			}
		},

		//返回一个元素节点内的直接文本子节点
		//recursive是否递归子节点
		'getTextNodes':function(node,recursive){
			var res = [];
			if(typeof(node) == 'undefined'){
				node = document.body;
			}
			if(typeof(recursive) == 'undefined'){
				recursive = false;
			}
			for(var i = 0,len = node.childNodes.length;i < len; i++){
				if(node.childNodes[i].nodeType == 3){
					res.push(node.childNodes[i]);
				}
			}
			if(recursive){
				MarkUtil.traverseDOM(node,function(n){
					if(n.nodeType == 3){
						res.push(n);
						//console.log(n);
					}
				});
			}
			return res;
		},

		//加载高亮数据，objBookmarkData是当前书签的高亮数据json对象，其中的notes保存了各个高亮部分的数据
		"loadMarkData" : function(objBookmarkData){

			//console.log("loading mark data...",objBookmarkData);
			if(typeof objBookmarkData == "object" && objBookmarkData.notes ){

				//对于包含数据版本信息的，将数据版本号存入当前MarkUtil属性，以备后用
				if( objBookmarkData.dataVersion ){
					MarkUtil.setDataFormatVersion(objBookmarkData.dataVersion);
				}

				//解析高亮数据
				MarkUtil.addMarks(objBookmarkData.notes);

			}else{
				console.log("传入的数据格式有误");
			}

		},

		//根据高亮数组添加效果，arrMarkData就是当前书签笔记数据对象的notes部分
		"addMarks":function(arrMarkData){

			if(arrMarkData.length > 0){

				_.each(arrMarkData,function(ele,idx){

					//获取所有标记类标签
					var $t = $("." + MarkUtil.markSpanClassName);
					var noteID = ele.noteID;


					//遍历每个note中的selection数组,找到对应的标记类span，添加高亮
					_.each(ele.selections,function(e,idx){

						//给span.t的文本节点包裹高亮span标签,但需要排除没有文本节点的元素节点，例如<span class="sqt"></span>
						if(e.tIndex != -1){
							var node = $t.get(e.tIndex);

							//！！！！分享出去的页面上存在位置偏移，此处的偏移量为2，如果将来分享页面有变化，此处可能会需要调整
							//另外ios下旧笔记数据在安卓系统上也可能产生2个位移的偏差，但此处暂不处理
							// if($("body").hasClass("origin") && window.location.href.match(/http/i) != null && MarkUtil.sysType == "ios"){
								// node = $t.get(e.tIndex - 2);
							// }
							// if(window.location.href.match(/http/i == null) && window.navigator.userAgent.match(/Android/i) != null && MarkUtil.sysType == "ios"){
								// node = $t.get(e.tIndex - 2);
							// }
							// if(window.location.href.match(/http/i == null) && window.navigator.userAgent.match(/iPhone|iPad|iPod/i) != null && MarkUtil.sysType == "android"){
								// node = $t.get(e.tIndex + 2);
							// }

							if(node.childNodes.length == 1 && node.childNodes[0].nodeType == 3){
								if(MarkUtil.dataFormatVersion == 2){
									MarkUtil.addMarkV2(node.childNodes[0],e.startOffset,e.endOffset,noteID);
								}else{
									MarkUtil.addMark(node.childNodes[0],e.startOffset,e.endOffset,noteID);
								}

							}
						}

					});

					//如果note中有注释则添加注释按钮
					//！注意：此处代码必须在高亮效果执行显示后才能正确执行
					if(typeof(ele.comment) != 'undefined' && ele.comment.length > 0){
						MarkUtil.addComment(noteID);
					}


				});
			}
		},

		//给指定节点内的文本节点从起始位置到终止位置添加标记,oNode必须为为文本节点
		'addMark':function (oNode,startOffset,endOffset,noteID){

			//检查数据合法性，排除非文本节点
			if(oNode.nodeValue == null || oNode.nodeType != 3){
				return false;
			}

			//设置高亮选区
			var range = document.createRange();

			range.setStart(oNode,startOffset);
			range.setEnd(oNode,endOffset);

			var span = document.createElement('span');
			span.setAttribute('class',MarkUtil.activeClassName);
			span.setAttribute('data-noteid',noteID);

			//给高亮部分添加ID属性，但只能添加一个
			var spanWithNoteID = document.getElementById(noteID);
			if(spanWithNoteID == null){
				//span.setAttribute("id", noteID);
			}
			range.surroundContents(span);

			//清除所有选中区域，将selection置为none
			window.getSelection().removeAllRanges();

		},

		//v2版addMark方法
		"addMarkV2" : function(oNode,startOffset,endOffset,noteID){

			//检查数据合法性，排除非文本节点
			if(oNode.nodeValue == null || oNode.nodeType != 3){
				return false;
			}

			//设置高亮选区
			var range = document.createRange();

			range.setStart(oNode,startOffset);
			range.setEnd(oNode,endOffset);

			var span = document.createElement('span');
			span.setAttribute('class',MarkUtil.activeClassName);
			span.setAttribute('data-noteid',noteID);

			//给高亮部分添加ID属性，但只能添加一个
			var spanWithNoteID = document.getElementById(noteID);
			if(spanWithNoteID == null){
				//span.setAttribute("id", noteID);
			}
			range.surroundContents(span);

			////V2版新增代码////
			//对选中文字高亮后处于同一文本节点内的剩余文本进行处理，包裹成新的标记类标签，不管文本内容是否为空
			try{

				var children = range.commonAncestorContainer.childNodes;
				for(var i = 0; i < children.length; i++){

					if(children[i].nodeType == document.TEXT_NODE){
						var range = document.createRange();
						var spanMark = document.createElement('span');
						spanMark.setAttribute('class',MarkUtil.markSpanClassName);
						range.selectNode(children[i]);
						range.surroundContents(spanMark);
					}

				}

			}catch(err){
				console.log(err.name + " : " + err.message);
			}

			//清除所有选中区域，将selection置为none
			window.getSelection().removeAllRanges();

		},

		//给指定节点添加注释
		"addComment" : function(noteID){
			//alert("添加注释：noteID" + noteID);
			var $note = $("." + MarkUtil.activeClassName + "[data-noteid='" + noteID + "']");
			if($note.last().next(".comment-icon").length == 0 ){
				$note.last().after('<i class="comment-icon" data-noteid="'+ noteID +'"><b>...</b></i>');
			}

		},

		//获取选中区域文本的起止数据
		"getSelectionData" : function(objSelection){

			var selection = typeof objSelection == "undefined" ? window.getSelection() : objSelection;

			var range = document.createRange();
			var $tClass = $("." + MarkUtil.markSpanClassName);
			var selectionData = [];

			var direction = 1;//选取文字方向，1：正向，-1：反向

			var startNodeIndex = MarkUtil.getElementIndexOfClassName(selection.anchorNode.parentElement,MarkUtil.markSpanClassName);
			var endNodeIndex = MarkUtil.getElementIndexOfClassName(selection.focusNode.parentElement,MarkUtil.markSpanClassName);

			//打印起止文本节点tIndex
			console.log("start tIndex:",startNodeIndex);
			console.log("end tIndex:", endNodeIndex);

			//当反向选择时，交换起止节点
			if(startNodeIndex > endNodeIndex){
				direction = -1;
				var t = startNodeIndex;
				startNodeIndex = endNodeIndex;
				endNodeIndex = t;

			}


			//按是否跨节点，分为两种情况
			if(startNodeIndex == endNodeIndex){

				//当不跨节点时，选择文字都位于同一个t标签内时
				data = {
					"tIndex" : startNodeIndex,
					"startOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.anchorOffset : selection.focusOffset,
					"endOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.focusOffset : selection.anchorOffset
				}
				selectionData.push(data);
			}else{

				//当跨节点时，可能会出现跨2个节点和跨3个节点以上的情况，循环起止节点
				//已知问题：过渡node中不包含任何文本节点时，调用node.childNodes[0]会出错，此情况已在addMarks方法中做了排除
				//当anchorNode或focusNode不是文本节点时，调用nodeValue.length时会出错，例如包含图片的a标签，恰好选到图片下一段文字之前时，focusNode为下一段文字的元素节点
				if(direction == 1){

					for(var i = startNodeIndex ; i <= endNodeIndex; i += 1){


						if(i == startNodeIndex){ //起始节点

							data = {
								"tIndex" : i,
								"startOffset" : selection.anchorOffset,
								"endOffset" : selection.anchorNode.nodeValue.length//$tClass.get(i).childNodes[0].nodeValue.length//
							};
						}else if(i == endNodeIndex){ //终止节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.focusOffset
							};
						}else{ //其他过渡节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}else if(direction == -1){

					for(var i = startNodeIndex ; i <= endNodeIndex; i += 1){
						if(i == startNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : selection.focusOffset,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//selection.focusNode.nodeValue.length //
							};
						}else if(i == endNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.anchorOffset
							};
						}else{
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}

			}

			return selectionData;

		},


		//获取选中区域文本的起止数据
		"getSelectionDataV2" : function(objSelection){

			var selection = typeof objSelection == "undefined" ? window.getSelection() : objSelection;
			var $tClass = $("." + MarkUtil.markSpanClassName);
			//console.log("初始selection:",selection);

			//默认认为选中的selection都是文本节点，但还需要判断anchorNode和focusNode不为文本节点的情况
			//例如选中了图片链接，或者恰好选中了整个元素节点，当节点不为文本节点时，需要另外记录所选元素节点的tagName和tagIndex
			//其中tagName用于获取tagIndex，并区分其他类型节点；tagIndex用于找到定位此类型的节点位置，tagIndex应当相对固定，不能随DOM结构变化而变。
			//在页面载入数据时，判断数据中endOffset值的合法性，如果为undefined，则表明不能依据此值定为结束节点,应该以tagName和tagIndex来确定结束节点。
			//使用range对象时，也要注意。文本是可以用span标签surround的，但元素节点不可用surround方法，需要另想办法
			//一般，只有起止节点才可能出现非文本节点的情况

			//起止节点不是文本节点，或是文本节点但父级节点不是mark元素（如选中了已高亮文本或者注释按钮文本，默认高亮区域文本是不能被选中的，但也要考虑其他情况），则认为其非法
			//经过测试，目前只发现选中文本时起止节点有两种情况，一种是文本节点，一种是元素节点,默认startNodeIndex和endNodeIndex为0，元素节点为-1，文本节点则为0或正整数值，最大不超过节点的文本长度
			var startMarkNodeIndex = endMarkNodeIndex = 0;

			if( selection.anchorNode.nodeType == 3 && $(selection.anchorNode.parentElement).hasClass(MarkUtil.markSpanClassName) ){
				startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(selection.anchorNode.parentElement,MarkUtil.markSpanClassName);
			}else{
				startMarkNodeIndex = -1;
			}

			if( selection.focusNode.nodeType == 3 && $(selection.focusNode.parentElement).hasClass(MarkUtil.markSpanClassName) ){
				endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(selection.focusNode.parentElement,MarkUtil.markSpanClassName);
			}else{
				endMarkNodeIndex = -1;
			}


			//根据起止节点情况区分，当起始节点为元素节点并且结束节点上文本节点，例如选区从一段文本的开头到此段落的中间，或从一张图片到一段文本的中间
			if(startMarkNodeIndex == -1 && endMarkNodeIndex != -1){

				//anchor节点不是文本节点，需要向前或向后找到最近的mark节点作为anchor节点
				//console.log("起始节点不是文本节点");

				//根据起止节点在DOM中的顺序判断选择的方向，从前向后选和从后向前选，并找到起始节点到结束节点之间距离起始节点最近的一个文本节点，最后重建selection
				//但移动设备上可以对选中的文字既向前选又向后选，尚没有明确这种情况下的anchorNode和focusNode是如何定义的，猜测其一定有anchorNode和focusNode,而不可能两端都是anchorNode或focusNode
				var beginIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode);
				var stopIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode.parentElement);

				if(stopIndex > beginIndex){
					//从anchorNode往后找,总能找到一个标记节点，且包含了非空文字
					var i = beginIndex + 1;
					while( i <= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(document.all[i].childNodes[0],0);//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							range.setEnd(selection.focusNode,selection.focusOffset);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i++;
					}
				}else{
					//从anchorNode往前找
					var i = beginIndex ;
					while( i >= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.focusNode,selection.focusOffset);
							range.setEnd(document.all[i].childNodes[0],document.all[i].childNodes[0].nodeValue.length);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i--;
					}
				}

			}

			//起始位置在文字节点中，但结束节点不是文字节点
			if(startMarkNodeIndex != -1 && endMarkNodeIndex == -1){

				//console.log("终止节点不是文本节点");
				//console.log("处理前selection:",selection);
				//注意，此处反转了起止计算节点
				var beginIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode);
				var stopIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode.parentElement);

				if(stopIndex > beginIndex){
					//从anchorNode往后找
					var i = beginIndex + 1;
					while( i <= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.anchorNode,selection.anchorOffset);//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							range.setEnd(document.all[i].childNodes[0],0);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i++;
					}
				}else{
					//从anchorNode往前找
					var i = beginIndex ;
					while( i >= stopIndex){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							var range = document.createRange();
							range.setStart(selection.anchorNode,selection.anchorOffset);
							range.setEnd(document.all[i].childNodes[0],document.all[i].childNodes[0].nodeValue.length);
							selection.removeAllRanges();
							selection.addRange(range);
							break;
						}
						i--;
					}
				}
				//console.log("处理后selection:",selection);

			}

			//起止位置都不是文字节点
			if(startMarkNodeIndex == -1 && endMarkNodeIndex == -1){
				console.log("起止节点都不是文本节点");
				//注意，此种情况有可能是选中了整个元素节点(例如在ios8中会出现整个节点选中的情况)，暂不处理
				//return false;
				//先判断选择方向，如果反向选，则将起止节点反转，

				var anchorNodeIndex = MarkUtil.getNodeIndexInDOM(selection.anchorNode);
				var focusNodeIndex = MarkUtil.getNodeIndexInDOM(selection.focusNode);
				/*
				//锚节点与焦点节点为同一个节点，例如出现单独一行span标记标签，或单独一个整段,略复杂，稍后开发
				if(anchorNodeIndex == focusNodeIndex){
					var node = selection.anchorNode;
					//只要这个节点中有文字且是标记节点或包含标记节点，则从第一个mark标记开始到最后一个mark标记结束创建selection
					if( ( node.className.match(MarkUtil.markSpanClassName) != null || MarkUtil.hasMarkNode(node) ) && node.innerText != "" ){

						var children = node.childNodes,len = node.children.length;
						for(var i = 0; i < len; i++){
							if(children[i])
						}
					}

				}*/

				//跨节点且锚节点在前
				if(anchorNodeIndex < focusNodeIndex){

					var range = document.createRange();
					var i = anchorNodeIndex;
					while( i <= focusNodeIndex ){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							range.setStart( document.all[i].childNodes[0] , 0 );//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							break;
						}
						i++;
					}

					var j = focusNodeIndex;
					while( j >= anchorNodeIndex ){
						if( $( document.all[j] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[j]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[j],MarkUtil.markSpanClassName);
							range.setEnd( document.all[j] , document.all[j].childNodes[0].nodeValue.length );//document.all[i]可能包含不止一个文本节点，此处可能会产生错误，留待后面处理
							break;
						}
						j--;
					}

					selection.removeAllRanges();
					selection.addRange(range);
				}

				//跨节点且锚节点在后
				if(anchorNodeIndex > focusNodeIndex){
					var range = document.createRange();
					var i = anchorNodeIndex;
					while( i >= focusNodeIndex ){
						if( $( document.all[i] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[i]) ){
							startMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[i],MarkUtil.markSpanClassName);
							range.setEnd( document.all[i].childNodes[0] , document.all[i].childNodes[0].nodeValue.length );
							break;
						}
						i--;
					}

					var j = focusNodeIndex;
					while( j <= anchorNodeIndex ){
						if( $( document.all[j] ).hasClass(MarkUtil.markSpanClassName) && MarkUtil.hasTextNode(document.all[j]) ){
							endMarkNodeIndex = MarkUtil.getElementIndexOfClassName(document.all[j],MarkUtil.markSpanClassName);
							range.setStart( document.all[j] , 0 );
							break;
						}
						j++;
					}

					selection.removeAllRanges();
					selection.addRange(range);
				}
			}


			//开始根据选择方向处理数据
			var selectionData = [];
			var direction = 1;//选取文字方向，1：正向，-1：反向

			//当反向选择时，交换起止节点
			if(startMarkNodeIndex > endMarkNodeIndex){
				direction = -1;
				var t = startMarkNodeIndex;
				startMarkNodeIndex = endMarkNodeIndex;
				endMarkNodeIndex = t;
			}

			//按是否跨节点，分为两种情况
			if(startMarkNodeIndex == endMarkNodeIndex){

				//当不跨节点时，选择文字都位于同一个t标签内时
				data = {
					"tIndex" : startMarkNodeIndex,
					"startOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.anchorOffset : selection.focusOffset ,
					"endOffset" : (selection.anchorOffset < selection.focusOffset) ? selection.focusOffset : selection.anchorOffset
				}
				selectionData.push(data);

			}else{

				//当跨节点时，可能会出现跨2个节点和跨3个节点以上的情况，循环起止节点
				//已知问题：过渡node中不包含任何文本节点时，调用node.childNodes[0]会出错，此情况已在addMarks方法中做了排除
				//当anchorNode或focusNode不是文本节点时，调用nodeValue.length时会出错，例如包含图片的a标签，恰好选到图片下一段文字之前时，focusNode为下一段文字的元素节点

				if(direction == 1){

					for(var i = startMarkNodeIndex ; i <= endMarkNodeIndex; i += 1){

						//如果选中的mark节点中不仅包含纯文本节点，则跳过
						if( $tClass.get(i).childNodes.length > 1 && $tClass.get(i).childNodes[0].nodeType != document.TEXT_NODE ){
							continue;
						}

						if(i == startMarkNodeIndex){ //起始节点

							data = {
								"tIndex" : i,
								"startOffset" : selection.anchorOffset,
								"endOffset" : selection.anchorNode.nodeValue.length//$tClass.get(i).childNodes[0].nodeValue.length//
							};
						}else if(i == endMarkNodeIndex){ //终止节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.focusOffset
							};
						}else{ //其他过渡节点
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : MarkUtil.hasTextNode(MarkUtil.getMarkNodeByIndex(i)) ? $tClass.get(i).childNodes[0].nodeValue.length : 0//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}else if(direction == -1){

					for(var i = startMarkNodeIndex ; i <= endMarkNodeIndex; i += 1){

						//如果选中的mark节点中不仅包含纯文本节点，则跳过
						if( $tClass.get(i).childNodes.length > 1 && $tClass.get(i).childNodes[0].nodeType != document.TEXT_NODE ){
							continue;
						}

						if(i == startMarkNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : selection.focusOffset,
								"endOffset" : $tClass.get(i).childNodes[0].nodeValue.length//selection.focusNode.nodeValue.length //
							};
						}else if(i == endMarkNodeIndex){
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : selection.anchorOffset
							};
						}else{
							data = {
								"tIndex" : i,
								"startOffset" : 0,
								"endOffset" : MarkUtil.hasTextNode(MarkUtil.getMarkNodeByIndex(i)) ? $tClass.get(i).childNodes[0].nodeValue.length : 0//$tClass.get(i).innerText.length//
							};
						}
						selectionData.push(data);
					}

				}

			}
			return selectionData;


		},

		//格式化overlaydiv中的正文文本
		'formatTextNodes':function(){
			//获取所有的文本节点,遍历后加上t标签
			//此处可以更改为其他节点，防止内容以外的元素被格式化
			var textNodes = MarkUtil.getTextNodes(document.body,true);

			_.each(textNodes,function(ele,idx){

				//2016.8.12
				//排除正文overlaydiv以外的节点,在分享出去的页面上，那些节点可能包含了广告等部分
				if($(ele.parentElement).parents("#overlaydiv").length == 0){
					return false;
				}

				//改进方案：将一个文本节点按标点分割分割为若干个文本节点，并包裹为标记节点
				var text = ele.nodeValue;
				//var regPunc = /，|。|！|；|：|？/g;//原标点减少为3种，从第二版代码起使用
				//var regPunc = /。|！|？/g;//但修改后会影响原有高亮数据，暂时没有好的办法
				//根据数据版本号格式化文本，并确定切分标点
				var regPunc;
				if(MarkUtil.dataFormatVersion == 1){
					regPunc = /，|。|！|；|：|？/g;
				}else if(MarkUtil.dataFormatVersion == 2){
					regPunc = /。|！|？/g;
				}
				var arrNodes = [];
				if(text != null){
					if(text.match(regPunc) != null){
						var html = text.replace(regPunc,'$&</span><span class="'+ MarkUtil.markSpanClassName +'">');
						html = '<span class="'+ MarkUtil.markSpanClassName +'">' + html + '</span>';
						$(ele).replaceWith(html);
					}else{
						$(ele).wrap('<span class="'+ MarkUtil.markSpanClassName +'"></span>');
					}
				}

			});
			
			//fuck it! ios会在开始增加2个空白mark节点！
			//为了维持公平需要在安卓和web页面也同样增加2个！
			//！！目前只了解到除ios版收趣外其他都需要加，其他情况暂时不知道
			//新改后的代码执行时，ios上也出现了解析后sqt数量与做笔记时sqt数量不一致的情况，因此ios也加上两个空mark节点
			//if(navigator.userAgent.match(/iPhone|iPad|iPod/i)==null){
				//$('<span class="sqt"> </span><span class="sqt"> </span>').prependTo("#overlaydiv")
			//}
			if(MarkUtil.dataFormatVersion == 1 ){
				$('<span class="sqt"> </span><span class="sqt"> </span>').prependTo("#overlaydiv")
			}

		}

	};
	window.MarkUtil = MarkUtil;
})(jQuery);

/**
* 正文工具组件
* ver 1.0
*/
(function($){
	var ArticleUtil = {

		//清理正文空白节点和空白文本，但仅限于overlaydiv
		"removeBlankNode" : function(){
			//删除空白文本
			var emptyTextNodes = [];
			var container_div = document.getElementById("overlaydiv");
			MarkUtil.traverseDOM(container_div,function(obj){
				if(obj.nodeType == 3 && (obj.nodeValue.match(/\S/g) == null) ){
					emptyTextNodes.push(obj);
				}
			});
			_.each(emptyTextNodes,function(ele,idx){
				$(ele).remove();
			});

			//删除空白元素节点
			var emptyElementNodes = [];
			var exceptionNode = new RegExp(/IMG|EMBED|INPUT|AREA|LINK|VIDEO|AUDIO|BR/g);
			var content_div = document.getElementById('innerdiv');
			MarkUtil.traverseDOM(content_div,function(obj){
				if( obj.nodeType == 1 && obj.nodeName.match(exceptionNode) == null && ( obj.childNodes.length == 0 || obj.innerHTML.match(/\S/g) == null ) ){
					emptyElementNodes.push(obj);
				}
			});
			_.each(emptyElementNodes,function(ele,idx){
				$(ele).remove();
			});
		}
	};
	window.ArticleUtil = ArticleUtil;
})(jQuery);


